﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace BayesNetwork.Classes
{
    public class BayesEdge
    {
        public string Influencer { get; set; }
        public string Influenced { get; set; }
        public double Influence { get; set; }
        public double NegativeInfluence { get; set; }
        public bool PastInfluence { get; set; }

        public BayesEdge(string influencer, string influenced, double influence)
            : this(influencer, influenced, influence, 2 - influence)
        {}

        public BayesEdge(string influencer, string influenced, double influence, double negativeInfluence)
        {
            Influencer = influencer;
            Influenced = influenced;
            Influence = influence;
            NegativeInfluence = negativeInfluence;
            PastInfluence = false;
        }

        // 'A => B' means 'A influences B'
        public override string ToString()
        {
            return "<BayesEdge>{'" + Influencer + "' => '" + Influenced + "', P(" + Influence+ "), NP(" + NegativeInfluence + "}";
        }
    }
}
