﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace BayesNetwork.Classes
{
    public class BayesNode
    {
        public string Name { get; set; }
        public double Probability { get; set; }
        public bool? ObservedValue { get; set; }
        public bool ManuallySet { get; set; }
        public String me_cat { get; set; } //Mutually Exclusive Category.
        //If a node doesn't have an me_cat, then it is a regular node. 
        //If it has an me_cat, then either it must be true, 
        //or any of it's mutually exclusive partners must be true.

        /*  
         * If you wanted to make a node with all parameters then:
         * new BayesNode(0.4){Name = "myNode", ObservedValue = false}
         */
        public BayesNode(double probability)
        { Probability = probability; }

        public override string ToString()
        {
            return "<BayesNode>{\"" + Name + "\", P(" + Probability.ToString("N2") + "), " + ((ObservedValue == null) ? "Unknown" : ObservedValue.ToString()) + "}";
        }
    }
}
